/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package webService;

import javax.ws.rs.*;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.UriInfo;

/**
 * REST Web Service
 *
 * @author fontanel
 */
@Path("GestionListe")
public class WebServiceGestionListe {

    @Context
    private UriInfo context;
    
    // Création d'une tableau de liste de personnes
    static protected listePersonne [] tableauPersonnes = new listePersonne[5];
    
    // Indice de création dans le tableau de liste
    static public int indiceTableau = 0;

    /**
     * Creates a new instance of WebServiceGestionListe
     */
    public WebServiceGestionListe() {
    }
    
    // Méthode permettant la création d'une liste de personne
    @POST
    @Path("creerlistPersonne/{nbrePersonne}")
    @Produces("application/json")
    public String CreerListePersonne(@PathParam("nbrePersonne") int nbrePersonne) 
    { 
        // Création de la liste de personne
        tableauPersonnes[indiceTableau] = new listePersonne(nbrePersonne);
        
        // On avance l'indice dans le tableau pour la prochaine liste
        indiceTableau++;
        return "La liste de personne est bien créée avec l'id liste suivant : "+(indiceTableau-1);
    }

    // Méthode permettant d'ajouter une personne à une liste de personne
    @POST
    @Path("ajouterpersonnedanslistepersonne/{idListe}/ajoutPersonne/{nom}-{prenom}")
    @Produces("application/json")
    public String ajouterPersonneDansListePersonne(@PathParam("idListe") int idListe, @PathParam("nom") String nom,@PathParam("prenom") String prenom) 
    { 
        // On ajoute la personne demandée dans la liste
        String resultat = tableauPersonnes[idListe].ajouterUnePersonneDanslistPersonne(nom,prenom);
        return resultat;
    }   
    
    // Méthode permettant de modifier le nom et le prénom d'une personne
    // dans la liste
    @PUT
    @Path("modifierpersonnedanslistepersonne/{idListe}-{idPersonne}/modifierNomPrenom/{nom}-{prenom}")
    @Produces("application/json")
    public String modifierPersonneDansListePersonne(@PathParam("idListe") int idListe, @PathParam("idPersonne") int idPersonne, @PathParam("nom") String nom,@PathParam("prenom") String prenom) 
    { 
        // On modifie la personne demandée dans la liste
        String resultat = tableauPersonnes[idListe].modifierUnePersonneDanslistPersonne(idPersonne,nom,prenom);
        return resultat;
    } 
    
    // Méthode permettant de consulter une personne dans la liste
    @GET
    @Path("consulterpersonnedanslistepersonne/{idListe}-{idPersonne}")
    @Produces("application/json")
    public String consulterPersonneDansListePersonne(@PathParam("idListe") int idListe, @PathParam("idPersonne") int idPersonne) 
    {
        // On consulte la personne demandée
        String resultat = tableauPersonnes[idListe].consulterUnePersonneDanslistPersonne(idPersonne);
        return resultat;
    }
    
    // Méthode permettant de consulter toutes les personnes d’une liste de personne
    @GET
    @Path("consulterlistepersonne/{idListe}")
    @Produces("application/json")
    public String consulterListePersonne(@PathParam("idListe") int idListe) 
    {
        // On consulte la personne demandée
        String resultat = tableauPersonnes[idListe].consulterListPersonne();
        return resultat;
    }
    
    // Méthode permettant de supprimer une personnes d'une liste de personnes
    @DELETE
    @Path("supprimerpersonnedanslistepersonne/{idListe}-{idPersonne}")
    @Produces("application/json")
    public String supprimerPersonneDansListePersonne(@PathParam("idListe") int idListe, @PathParam("idPersonne") int idPersonne) 
    {        
        // On supprime la personne demandée
        String retour = tableauPersonnes[idListe].supprimerUnePersonneDanslistPersonne(idPersonne);
        return retour;
    }
    
}
